diff --git a/gcc/analyzer/program-state.cc b/gcc/analyzer/program-state.cc
index 6ad7dea7cc7..ae444ada7f3 100644
--- a/gcc/analyzer/program-state.cc
+++ b/gcc/analyzer/program-state.cc
@@ -116,493 +116,64 @@ extrinsic_state::get_model_manager () const
 
 /* sm_state_map's ctor.  */
 
-sm_state_map::sm_state_map ()
-: m_map (), m_global_state (0)
-{
-}
-
 /* Clone the sm_state_map.  */
 
-sm_state_map *
-sm_state_map::clone () const
-{
-  return new sm_state_map (*this);
-}
-
 /* Clone this sm_state_map, remapping all svalue_ids within it with ID_MAP.
 
    Return NULL if there are any svalue_ids that have sm-state for which
    ID_MAP maps them to svalue_id::null (and thus the clone would have lost
    the sm-state information). */
 
-sm_state_map *
-sm_state_map::clone_with_remapping (const one_way_svalue_id_map &id_map) const
-{
-  sm_state_map *result = new sm_state_map ();
-  result->m_global_state = m_global_state;
-  for (map_t::iterator iter = m_map.begin ();
-       iter != m_map.end ();
-       ++iter)
-    {
-      svalue_id sid = (*iter).first;
-      gcc_assert (!sid.null_p ());
-      entry_t e = (*iter).second;
-      /* TODO: what should we do if the origin maps from non-null to null?
-	 Is that loss of information acceptable?  */
-      id_map.update (&e.m_origin);
-
-      svalue_id new_sid = id_map.get_dst_for_src (sid);
-      if (new_sid.null_p ())
-	{
-	  delete result;
-	  return NULL;
-	}
-      result->m_map.put (new_sid, e);
-    }
-  return result;
-}
-
 /* Print this sm_state_map (for SM) to PP.
    If MODEL is non-NULL, print representative tree values where
    available.  */
 
-void
-sm_state_map::print (const state_machine &sm, const region_model *model,
-		     pretty_printer *pp) const
-{
-  bool first = true;
-  pp_string (pp, "{");
-  if (m_global_state != 0)
-    {
-      pp_printf (pp, "global: %s", sm.get_state_name (m_global_state));
-      first = false;
-    }
-  for (map_t::iterator iter = m_map.begin ();
-       iter != m_map.end ();
-       ++iter)
-    {
-      if (!first)
-	pp_string (pp, ", ");
-      first = false;
-      svalue_id sid = (*iter).first;
-      sid.print (pp);
-
-      entry_t e = (*iter).second;
-      pp_printf (pp, ": %s", sm.get_state_name (e.m_state));
-      if (model)
-	if (tree rep = model->get_representative_tree (sid))
-	  {
-	    pp_string (pp, " (");
-	    dump_quoted_tree (pp, rep);
-	    pp_character (pp, ')');
-	  }
-      if (!e.m_origin.null_p ())
-	{
-	  pp_string (pp, " (origin: ");
-	  e.m_origin.print (pp);
-	  if (model)
-	    if (tree rep = model->get_representative_tree (e.m_origin))
-	      {
-		pp_string (pp, " (");
-		dump_quoted_tree (pp, rep);
-		pp_character (pp, ')');
-	      }
-	  pp_string (pp, ")");
-	}
-    }
-  pp_string (pp, "}");
-}
-
 /* Dump this object (for SM) to stderr.  */
 
-DEBUG_FUNCTION void
-sm_state_map::dump (const state_machine &sm) const
-{
-  pretty_printer pp;
-  pp_show_color (&pp) = pp_show_color (global_dc->printer);
-  pp.buffer->stream = stderr;
-  print (sm, NULL, &pp);
-  pp_newline (&pp);
-  pp_flush (&pp);
-}
-
 /* Return true if no states have been set within this map
    (all expressions are for the start state).  */
 
-bool
-sm_state_map::is_empty_p () const
-{
-  return m_map.elements () == 0 && m_global_state == 0;
-}
-
 /* Generate a hash value for this sm_state_map.  */
 
-hashval_t
-sm_state_map::hash () const
-{
-  hashval_t result = 0;
-
-  /* Accumulate the result by xoring a hash for each slot, so that the
-     result doesn't depend on the ordering of the slots in the map.  */
-
-  for (map_t::iterator iter = m_map.begin ();
-       iter != m_map.end ();
-       ++iter)
-    {
-      inchash::hash hstate;
-      inchash::add ((*iter).first, hstate);
-      entry_t e = (*iter).second;
-      hstate.add_int (e.m_state);
-      inchash::add (e.m_origin, hstate);
-      result ^= hstate.end ();
-    }
-  result ^= m_global_state;
-
-  return result;
-}
-
 /* Equality operator for sm_state_map.  */
 
-bool
-sm_state_map::operator== (const sm_state_map &other) const
-{
-  if (m_global_state != other.m_global_state)
-    return false;
-
-  if (m_map.elements () != other.m_map.elements ())
-    return false;
-
-  for (map_t::iterator iter = m_map.begin ();
-       iter != m_map.end ();
-       ++iter)
-    {
-      svalue_id sid = (*iter).first;
-      entry_t e = (*iter).second;
-      entry_t *other_slot = const_cast <map_t &> (other.m_map).get (sid);
-      if (other_slot == NULL)
-	return false;
-      if (e != *other_slot)
-	return false;
-    }
-
-  gcc_checking_assert (hash () == other.hash ());
-
-  return true;
-}
-
 /* Get the state of SID within this object.
    States default to the start state.  */
 
-state_machine::state_t
-sm_state_map::get_state (svalue_id sid) const
-{
-  gcc_assert (!sid.null_p ());
-
-  if (entry_t *slot
-      = const_cast <map_t &> (m_map).get (sid))
-    return slot->m_state;
-  else
-    return 0;
-}
-
 /* Get the "origin" svalue_id for any state of SID.  */
 
-svalue_id
-sm_state_map::get_origin (svalue_id sid) const
-{
-  gcc_assert (!sid.null_p ());
-
-  entry_t *slot
-    = const_cast <map_t &> (m_map).get (sid);
-  if (slot)
-    return slot->m_origin;
-  else
-    return svalue_id::null ();
-}
-
 /* Set the state of SID within MODEL to STATE, recording that
    the state came from ORIGIN.  */
 
-void
-sm_state_map::set_state (region_model *model,
-			 svalue_id sid,
-			 state_machine::state_t state,
-			 svalue_id origin)
-{
-  if (model == NULL)
-    return;
-  equiv_class &ec = model->get_constraints ()->get_equiv_class (sid);
-  if (!set_state (ec, state, origin))
-    return;
-
-  /* Also do it for all svalues that are equal via non-cm, so that
-     e.g. (void *)&r and (foo *)&r transition together.  */
-  for (unsigned i = 0; i < model->get_num_svalues (); i++)
-    {
-      svalue_id other_sid = svalue_id::from_int (i);
-      if (other_sid == sid)
-	continue;
-
-      tristate eq = model->eval_condition_without_cm (sid, EQ_EXPR, other_sid);
-      if (eq.is_true ())
-	impl_set_state (other_sid, state, origin);
-    }
-}
-
 /* Set the state of EC to STATE, recording that the state came from
    ORIGIN.
    Return true if any states of svalue_ids within EC changed.  */
 
-bool
-sm_state_map::set_state (const equiv_class &ec,
-			 state_machine::state_t state,
-			 svalue_id origin)
-{
-  int i;
-  svalue_id *sid;
-  bool any_changed = false;
-  FOR_EACH_VEC_ELT (ec.m_vars, i, sid)
-    any_changed |= impl_set_state (*sid, state, origin);
-  return any_changed;
-}
-
-/* Set state of SID to STATE, bypassing equivalence classes.
-   Return true if the state changed.  */
-
-bool
-sm_state_map::impl_set_state (svalue_id sid, state_machine::state_t state,
-			      svalue_id origin)
-{
-  if (get_state (sid) == state)
-    return false;
-
-  /* Special-case state 0 as the default value.  */
-  if (state == 0)
-    {
-      if (m_map.get (sid))
-	m_map.remove (sid);
-      return true;
-    }
-  gcc_assert (!sid.null_p ());
-  m_map.put (sid, entry_t (state, origin));
-  return true;
-}
-
 /* Set the "global" state within this state map to STATE.  */
 
-void
-sm_state_map::set_global_state (state_machine::state_t state)
-{
-  m_global_state = state;
-}
-
 /* Get the "global" state within this state map.  */
 
-state_machine::state_t
-sm_state_map::get_global_state () const
-{
-  return m_global_state;
-}
-
 /* Handle CALL to unknown FNDECL with an unknown function body, which
    could do anything to the states passed to it.
    Clear any state for SM for the params and any LHS.
    Note that the function might be known to other state machines, but
    not to this one.  */
 
-void
-sm_state_map::purge_for_unknown_fncall (const exploded_graph &eg,
-					const state_machine &sm,
-					const gcall *call,
-					tree fndecl,
-					region_model *new_model,
-					region_model_context *ctxt)
-{
-  logger * const logger = eg.get_logger ();
-  if (logger)
-    {
-      if (fndecl)
-	logger->log ("function %qE is unknown to checker %qs",
-		     fndecl, sm.get_name ());
-      else
-	logger->log ("unknown function pointer for checker %qs",
-		     sm.get_name ());
-    }
-
-  /* Purge any state for parms.  */
-  tree iter_param_types = NULL_TREE;
-  if (fndecl)
-    iter_param_types = TYPE_ARG_TYPES (TREE_TYPE (fndecl));
-  for (unsigned arg_idx = 0; arg_idx < gimple_call_num_args (call); arg_idx++)
-    {
-      /* Track expected param type, where available.  */
-      if (iter_param_types)
-	{
-	  tree param_type = TREE_VALUE (iter_param_types);
-	  gcc_assert (param_type);
-	  iter_param_types = TREE_CHAIN (iter_param_types);
-
-	  /* Don't purge state if it was passed as a const pointer
-	     e.g. for things like strlen (PTR).  */
-	  if (TREE_CODE (param_type) == POINTER_TYPE)
-	    if (TYPE_READONLY (TREE_TYPE (param_type)))
-	      continue;
-	}
-      tree parm = gimple_call_arg (call, arg_idx);
-      svalue_id parm_sid = new_model->get_rvalue (parm, ctxt);
-      set_state (new_model, parm_sid, 0, svalue_id::null ());
-
-      /* Also clear sm-state from svalue_ids that are passed via a
-	 pointer.  */
-      if (TREE_CODE (parm) == ADDR_EXPR)
-	{
-	  tree pointee = TREE_OPERAND (parm, 0);
-	  svalue_id parm_sid = new_model->get_rvalue (pointee, ctxt);
-	  set_state (new_model, parm_sid, 0, svalue_id::null ());
-	}
-    }
-
-  /* Purge any state for any LHS.  */
-  if (tree lhs = gimple_call_lhs (call))
-    {
-      svalue_id lhs_sid = new_model->get_rvalue (lhs, ctxt);
-      set_state (new_model, lhs_sid, 0, svalue_id::null ());
-    }
-}
-
 /* Update this map based on MAP.  */
 
-void
-sm_state_map::remap_svalue_ids (const svalue_id_map &map)
-{
-  map_t tmp_map;
-
-  /* Build an intermediate map, using the new sids.  */
-  for (map_t::iterator iter = m_map.begin ();
-       iter != m_map.end ();
-       ++iter)
-    {
-      svalue_id sid = (*iter).first;
-      entry_t e = (*iter).second;
-
-      map.update (&sid);
-      map.update (&e.m_origin);
-      tmp_map.put (sid, e);
-    }
-
-  /* Clear the existing values.  */
-  m_map.empty ();
-
-  /* Copy over from intermediate map.  */
-  for (map_t::iterator iter = tmp_map.begin ();
-       iter != tmp_map.end ();
-       ++iter)
-    {
-      svalue_id sid = (*iter).first;
-      entry_t e = (*iter).second;
-
-      impl_set_state (sid, e.m_state, e.m_origin);
-    }
-}
-
 /* Purge any state for svalue_ids >= FIRST_UNUSED_SID.
    If !SM::can_purge_p, then report the state as leaking,
    using SM_IDX, CTXT, and MAP.
    Return the number of states that were purged.  */
 
-int
-sm_state_map::on_svalue_purge (const state_machine &sm,
-			       int sm_idx,
-			       svalue_id first_unused_sid,
-			       const svalue_id_map &map,
-			       impl_region_model_context *ctxt)
-{
-  /* TODO: ideally remove the slot directly; for now
-     do it in two stages.  */
-  auto_vec<svalue_id> to_remove;
-  for (map_t::iterator iter = m_map.begin ();
-       iter != m_map.end ();
-       ++iter)
-    {
-      svalue_id dst_sid ((*iter).first);
-      if (dst_sid.as_int () >= first_unused_sid.as_int ())
-	{
-	  /* Complain about leaks here.  */
-	  entry_t e = (*iter).second;
-
-	  if (!sm.can_purge_p (e.m_state))
-	    ctxt->on_state_leak (sm, sm_idx, dst_sid, first_unused_sid,
-				 map, e.m_state);
-
-	  to_remove.safe_push (dst_sid);
-	}
-      else if ((*iter).second.m_origin.as_int () >= first_unused_sid.as_int ())
-	{
-	  /* If the origin svalue is being purged, then reset it to null.  */
-	  (*iter).second.m_origin = svalue_id::null ();
-	}
-    }
-
-  int i;
-  svalue_id *dst_sid;
-  FOR_EACH_VEC_ELT (to_remove, i, dst_sid)
-    m_map.remove (*dst_sid);
-
-  return to_remove.length ();
-}
-
 /* Set the state of CHILD_SID to that of PARENT_SID.  */
 
-void
-sm_state_map::on_inherited_svalue (svalue_id parent_sid,
-				   svalue_id child_sid)
-{
-  state_machine::state_t state = get_state (parent_sid);
-  impl_set_state (child_sid, state, parent_sid);
-}
-
 /* Set the state of DST_SID to that of SRC_SID.  */
 
-void
-sm_state_map::on_cast (svalue_id src_sid,
-		       svalue_id dst_sid)
-{
-  state_machine::state_t state = get_state (src_sid);
-  impl_set_state (dst_sid, state, get_origin (src_sid));
-}
-
 /* Purge state from SID (in response to a call to an unknown function).  */
 
-void
-sm_state_map::on_unknown_change (svalue_id sid)
-{
-  impl_set_state (sid, (state_machine::state_t)0, svalue_id::null ());
-}
-
 /* Assert that this object is sane.  */
 
-void
-sm_state_map::validate (const state_machine &sm,
-			int num_svalues) const
-{
-  /* Skip this in a release build.  */
-#if !CHECKING_P
-  return;
-#endif
-
-  for (map_t::iterator iter = m_map.begin ();
-       iter != m_map.end ();
-       ++iter)
-    {
-      svalue_id sid = (*iter).first;
-      entry_t e = (*iter).second;
-
-      gcc_assert (sid.as_int () < num_svalues);
-      sm.validate (e.m_state);
-      gcc_assert (e.m_origin.as_int () < num_svalues);
-    }
-}
-
 /* class sm_state_map2.  */
 
 /* sm_state_map2's ctor.  */
@@ -1165,47 +736,29 @@ sm_state_map2::canonicalize_svalue2 (const svalue2 *sval,
 
 program_state::program_state (const extrinsic_state &ext_state)
 : m_region_model2 (NULL),
-  m_region_model (NULL),
-  m_checker_states (ext_state.get_num_checkers ()),
-  m_checker_states2 (),
+  m_checker_states2 (ext_state.get_num_checkers ()),
   m_valid (true)
 {
-  if (ext_state.get_engine2 ())
-    {
-      engine2 *eng2 = ext_state.get_engine2 ();
-      region_model2_manager *mgr = eng2->get_model_manager ();
-      m_region_model2 = new region_model2 (mgr);
-    }
-  else
-    m_region_model = new region_model ();
+  engine2 *eng2 = ext_state.get_engine2 ();
+  region_model2_manager *mgr = eng2->get_model_manager ();
+  m_region_model2 = new region_model2 (mgr);
   const int num_states = ext_state.get_num_checkers ();
   for (int i = 0; i < num_states; i++)
-    m_checker_states.quick_push (new sm_state_map ());
-  if (ext_state.get_engine2 ())
-    for (int i = 0; i < num_states; i++)
-      {
-	sm_state_map2 *sm = new sm_state_map2 (ext_state.get_sm (i), i);
-	m_checker_states2.safe_push (sm);
-      }
+    {
+      sm_state_map2 *sm = new sm_state_map2 (ext_state.get_sm (i), i);
+      m_checker_states2.quick_push (sm);
+    }
 }
 
 /* program_state's copy ctor.  */
 
 program_state::program_state (const program_state &other)
 : m_region_model2 (NULL),
-  m_region_model (NULL),
-  m_checker_states (other.m_checker_states.length ()),
   m_checker_states2 (other.m_checker_states2.length ()),
   m_valid (true)
 {
-  if (other.m_region_model2)
-    m_region_model2 = new region_model2 (*other.m_region_model2);
-  if (other.m_region_model)
-    m_region_model = new region_model (*other.m_region_model);
+  m_region_model2 = new region_model2 (*other.m_region_model2);
   int i;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (other.m_checker_states, i, smap)
-    m_checker_states.quick_push (smap->clone ());
   sm_state_map2 *smap2;
   FOR_EACH_VEC_ELT (other.m_checker_states2, i, smap2)
     m_checker_states2.quick_push (smap2->clone ());
@@ -1217,22 +770,9 @@ program_state&
 program_state::operator= (const program_state &other)
 {
   delete m_region_model2;
-  if (other.m_region_model2)
-    m_region_model2 = new region_model2 (*other.m_region_model2);
-  delete m_region_model;
-  if (other.m_region_model)
-    m_region_model = new region_model (*other.m_region_model);
+  m_region_model2 = new region_model2 (*other.m_region_model2);
 
   int i;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (m_checker_states, i, smap)
-    delete smap;
-  m_checker_states.truncate (0);
-  gcc_assert (m_checker_states.space (other.m_checker_states.length ()));
-
-  FOR_EACH_VEC_ELT (other.m_checker_states, i, smap)
-    m_checker_states.quick_push (smap->clone ());
-
   sm_state_map2 *smap2;
   FOR_EACH_VEC_ELT (m_checker_states2, i, smap2)
     delete smap2;
@@ -1251,19 +791,11 @@ program_state::operator= (const program_state &other)
 /* Move constructor for program_state (when building with C++11).  */
 program_state::program_state (program_state &&other)
 : m_region_model2 (other.m_region_model2),
-  m_region_model (other.m_region_model),
-  m_checker_states (other.m_checker_states.length ()),
   m_checker_states2 (other.m_checker_states2.length ())
 {
   other.m_region_model2 = NULL;
-  other.m_region_model = NULL;
 
   int i;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (other.m_checker_states, i, smap)
-    m_checker_states.quick_push (smap);
-  other.m_checker_states.truncate (0);
-
   sm_state_map2 *smap2;
   FOR_EACH_VEC_ELT (other.m_checker_states2, i, smap2)
     m_checker_states2.quick_push (smap2);
@@ -1278,7 +810,6 @@ program_state::program_state (program_state &&other)
 program_state::~program_state ()
 {
   delete m_region_model2;
-  delete m_region_model;
 }
 
 /* Generate a hash value for this program_state.  */
@@ -1289,18 +820,9 @@ program_state::hash () const
   hashval_t result = 0;
 
   // TODO:
-#if 0
-  if (m_region_model2)
-    result ^= m_region_model2->hash ();
-#endif
-
-  if (m_region_model)
-    result ^= m_region_model->hash ();
+  //result ^= m_region_model2->hash ();
 
   int i;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (m_checker_states, i, smap)
-    result ^= smap->hash ();
   sm_state_map2 *smap2;
   FOR_EACH_VEC_ELT (m_checker_states2, i, smap2)
     result ^= smap2->hash ();
@@ -1316,20 +838,10 @@ program_state::hash () const
 bool
 program_state::operator== (const program_state &other) const
 {
-  if (m_region_model)
-    if (!(*m_region_model == *other.m_region_model))
-      return false;
-
-  if (m_region_model2)
-    if (!(*m_region_model2 == *other.m_region_model2))
-      return false;
+  if (!(*m_region_model2 == *other.m_region_model2))
+    return false;
 
   int i;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (m_checker_states, i, smap)
-    if (!(*smap == *other.m_checker_states[i]))
-      return false;
-
   sm_state_map2 *smap2;
   FOR_EACH_VEC_ELT (m_checker_states2, i, smap2)
     if (!(*smap2 == *other.m_checker_states2[i]))
@@ -1347,20 +859,10 @@ program_state::print (const extrinsic_state &ext_state,
 		      pretty_printer *pp) const
 {
   pp_printf (pp, "rmodel: ");
-  m_region_model->print (pp);
+  m_region_model2->dump_to_pp (pp, true, false);
   pp_newline (pp);
 
   int i;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (m_checker_states, i, smap)
-    {
-      if (!smap->is_empty_p ())
-	{
-	  pp_printf (pp, "%s: ", ext_state.get_name (i));
-	  smap->print (ext_state.get_sm (i), m_region_model, pp);
-	  pp_newline (pp);
-	}
-    }
   sm_state_map2 *smap2;
   FOR_EACH_VEC_ELT (m_checker_states2, i, smap2)
     {
@@ -1388,46 +890,21 @@ program_state::dump_to_pp (const extrinsic_state &ext_state,
 			   bool summarize, bool multiline,
 			   pretty_printer *pp) const
 {
-  if (!multiline)
-    pp_string (pp, "{");
-  if (m_region_model)
-    {
-      pp_printf (pp, "rmodel:");
-      if (multiline)
-	pp_newline (pp);
-      else
-	pp_string (pp, " {");
-      m_region_model->dump_to_pp (pp, summarize);
-      if (!multiline)
-	pp_string (pp, "}");
-    }
-  if (m_region_model2)
-    {
-      pp_printf (pp, "rmodel2:");
-      if (multiline)
-	pp_newline (pp);
-      else
-	pp_string (pp, " {");
-      m_region_model2->dump_to_pp (pp, true, multiline);
-      //m_region_model2->summarize_to_pp (pp, true);
-      if (!multiline)
-	pp_string (pp, "}");
-    }
+  if (!multiline)
+    pp_string (pp, "{");
+  {
+    pp_printf (pp, "rmodel2:");
+    if (multiline)
+      pp_newline (pp);
+    else
+      pp_string (pp, " {");
+    m_region_model2->dump_to_pp (pp, true, multiline);
+    //m_region_model2->summarize_to_pp (pp, true);
+    if (!multiline)
+      pp_string (pp, "}");
+  }
 
   int i;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (m_checker_states, i, smap)
-    {
-      if (!smap->is_empty_p ())
-	{
-	  if (!multiline)
-	    pp_space (pp);
-	  pp_printf (pp, "%s: ", ext_state.get_name (i));
-	  smap->print (ext_state.get_sm (i), m_region_model, pp);
-	  if (multiline)
-	    pp_newline (pp);
-	}
-    }
   sm_state_map2 *smap2;
   FOR_EACH_VEC_ELT (m_checker_states2, i, smap2)
     {
@@ -1498,16 +975,8 @@ void
 program_state::push_frame (const extrinsic_state &ext_state,
 			   function *fun)
 {
-  if (m_region_model2)
-    {
-      region_model2_context *ctxt = NULL; // FIXME
-      m_region_model2->push_frame (fun, NULL, ctxt);
-    }
-  else if (m_region_model)
-    {
-      impl_region_model_context ctxt (this, NULL, ext_state, ext_state.get_logger ());
-      m_region_model->push_frame (fun, NULL, &ctxt);
-    }
+  region_model2_context *ctxt = NULL; // FIXME
+  m_region_model2->push_frame (fun, NULL, ctxt);
 }
 
 /* FIXME.  */
@@ -1515,10 +984,7 @@ program_state::push_frame (const extrinsic_state &ext_state,
 function *
 program_state::get_current_function () const
 {
-  if (m_region_model2)
-    return m_region_model2->get_current_function ();
-  else
-    return m_region_model->get_current_function ();
+  return m_region_model2->get_current_function ();
 }
 
 /* Determine if following edge SUCC from ENODE is valid within the graph EG
@@ -1536,8 +1002,7 @@ program_state::get_current_function () const
 bool
 program_state::on_edge (exploded_graph &eg,
 			const exploded_node &enode,
-			const superedge *succ,
-			state_change *change)
+			const superedge *succ)
 {
   /* Update state.  */
   const program_point &point = enode.get_point ();
@@ -1551,47 +1016,26 @@ program_state::on_edge (exploded_graph &eg,
      Adding the relevant conditions for the edge could also trigger
      sm-state transitions (e.g. transitions due to ptrs becoming known
      to be NULL or non-NULL) */
-  if (m_region_model2)
-    {
-      impl_region_model2_context ctxt (eg, &enode,
-				      &enode.get_state (),
-				      this, change,
-				      last_stmt);
-      if (!m_region_model2->maybe_update_for_edge (*succ,
-						   last_stmt,
-						   &ctxt))
-	{
-	  logger * const logger = eg.get_logger ();
-	  if (logger)
-	    logger->log ("edge to SN: %i is impossible"
-			 " due to region_model2 constraints",
-			 succ->m_dest->m_index);
-	  return false;
-	}
-
-      program_state::detect_leaks2 (enode.get_state (), *this,
-				    NULL, eg.get_ext_state (),
-				    &ctxt);
-
-      return true;
-    }
-
-  impl_region_model_context ctxt (eg, &enode,
-				  &enode.get_state (),
-				  this, change,
-				  last_stmt);
-  if (!m_region_model->maybe_update_for_edge (*succ,
-					      last_stmt,
-					      &ctxt))
+  impl_region_model2_context ctxt (eg, &enode,
+				   &enode.get_state (),
+				   this,
+				   last_stmt);
+  if (!m_region_model2->maybe_update_for_edge (*succ,
+					       last_stmt,
+					       &ctxt))
     {
       logger * const logger = eg.get_logger ();
       if (logger)
 	logger->log ("edge to SN: %i is impossible"
-		     " due to region_model constraints",
+		     " due to region_model2 constraints",
 		     succ->m_dest->m_index);
       return false;
     }
 
+  program_state::detect_leaks2 (enode.get_state (), *this,
+				NULL, eg.get_ext_state (),
+				&ctxt);
+
   return true;
 }
 
@@ -1599,140 +1043,12 @@ program_state::on_edge (exploded_graph &eg,
    relevant at POINT.
    The idea is that we're more likely to be able to consolidate
    multiple (point, state) into single exploded_nodes if we discard
-   irrelevant state (e.g. at the end of functions).
-
-   Retain state affected by CHANGE, to make it easier to generate
-   state_change_events.  */
+   irrelevant state (e.g. at the end of functions).  */
 
 program_state
 program_state::prune_for_point (exploded_graph &eg,
 				const program_point &point,
-				const exploded_node *enode_for_diag,
-				state_change *change) const
-{
-  logger * const logger = eg.get_logger ();
-  LOG_SCOPE (logger);
-
-  function *fun = point.get_function ();
-  if (!fun)
-    return *this;
-
-  if (m_region_model2)
-    return prune_for_point2 (eg, point, enode_for_diag, change);
-
-  if (!m_region_model)
-    return *this;
-
-  program_state new_state (*this);
-
-  purge_stats stats;
-
-  const state_purge_map *pm = eg.get_purge_map ();
-  if (pm)
-    {
-      region_id_set purgeable_ssa_regions (new_state.m_region_model);
-      region_id frame_rid
-	= new_state.m_region_model->get_current_frame_id ();
-      frame_region *frame
-	= new_state.m_region_model->get_region <frame_region>(frame_rid);
-
-      /* TODO: maybe move to a member of region_model?  */
-
-      auto_vec<tree> ssa_names_to_purge;
-      for (frame_region::map_t::iterator iter = frame->begin ();
-	   iter != frame->end ();
-	   ++iter)
-	{
-	  tree var = (*iter).first;
-	  region_id rid = (*iter).second;
-	  if (TREE_CODE (var) == SSA_NAME)
-	    {
-	      const state_purge_per_ssa_name &per_ssa
-		= pm->get_data_for_ssa_name (var);
-	      if (!per_ssa.needed_at_point_p (point.get_function_point ()))
-		{
-		  region *region
-		    = new_state.m_region_model->get_region (rid);
-		  svalue_id sid = region->get_value_direct ();
-		  if (!sid.null_p ())
-		    {
-		      if (!new_state.can_purge_p (eg.get_ext_state (), sid))
-			{
-			  /* (currently only state maps can keep things
-			     alive).  */
-			  if (logger)
-			    logger->log ("not purging RID: %i for %qE"
-					 " (used by state map)",
-					 rid.as_int (), var);
-			  continue;
-			}
-
-		      /* Don't purge regions containing svalues that
-			 have a change of sm-state, to make it easier to
-			 generate state_change_event messages.  */
-		      if (change)
-			if (change->affects_p (sid))
-			  {
-			    if (logger)
-			      logger->log ("not purging RID: %i for %qE"
-					   " (affected by change)",
-					   rid.as_int (), var);
-			    continue;
-			  }
-		    }
-		  purgeable_ssa_regions.add_region (rid);
-		  ssa_names_to_purge.safe_push (var);
-		  if (logger)
-		    logger->log ("purging RID: %i for %qE", rid.as_int (), var);
-		  /* We also need to remove the region from the map.
-		     We're in mid-traversal, so the removal is done in
-		     unbind below.  */
-		}
-	    }
-	}
-
-      /* Unbind the regions from the frame's map of vars-to-regions.  */
-      unsigned i;
-      tree var;
-      FOR_EACH_VEC_ELT (ssa_names_to_purge, i, var)
-	frame->unbind (var);
-
-      /* Purge the regions.  Nothing should point to them, and they
-	 should have no children, as they are for SSA names.  */
-      new_state.m_region_model->purge_regions (purgeable_ssa_regions,
-					       &stats,
-					       eg.get_logger ());
-    }
-
-  /* Purge unused svalues.  */
-  // TODO: which enode to use, if any?
-  impl_region_model_context ctxt (eg, NULL,
-				  this,
-				  &new_state,
-				  change,
-				  NULL);
-  new_state.m_region_model->purge_unused_svalues (&stats, &ctxt);
-  if (logger)
-    {
-      logger->log ("num svalues purged: %i", stats.m_num_svalues);
-      logger->log ("num regions purged: %i", stats.m_num_regions);
-      logger->log ("num equiv_classes purged: %i", stats.m_num_equiv_classes);
-      logger->log ("num constraints purged: %i", stats.m_num_constraints);
-      logger->log ("num sm map items purged: %i", stats.m_num_client_items);
-    }
-
-  new_state.m_region_model->canonicalize (&ctxt);
-
-  return new_state;
-}
-
-/* FIXME.  */
-
-program_state
-program_state::prune_for_point2 (exploded_graph &eg,
-				 const program_point &point,
-				 const exploded_node *enode_for_diag,
-				 state_change *change) const
+				const exploded_node *enode_for_diag) const
 {
   logger * const logger = eg.get_logger ();
   LOG_SCOPE (logger);
@@ -1794,80 +1110,7 @@ program_state::prune_for_point2 (exploded_graph &eg,
 		logger->log ("purging region: TODO");
 	    }
 	}
-#if 0
-      region_id_set purgeable_ssa_regions (new_state.m_region_model);
-      region_id frame_rid
-	= new_state.m_region_model->get_current_frame_id ();
-      frame_region *frame
-	= new_state.m_region_model->get_region <frame_region>(frame_rid);
-
-      /* TODO: maybe move to a member of region_model?  */
-
-      auto_vec<tree> ssa_names_to_purge;
-      for (frame_region::map_t::iterator iter = frame->begin ();
-	   iter != frame->end ();
-	   ++iter)
-	{
-	  tree var = (*iter).first;
-	  region_id rid = (*iter).second;
-	  if (TREE_CODE (var) == SSA_NAME)
-	    {
-	      const state_purge_per_ssa_name &per_ssa
-		= pm->get_data_for_ssa_name (var);
-	      if (!per_ssa.needed_at_point_p (point.get_function_point ()))
-		{
-		  region *region
-		    = new_state.m_region_model->get_region (rid);
-		  svalue_id sid = region->get_value_direct ();
-		  if (!sid.null_p ())
-		    {
-		      if (!new_state.can_purge_p (eg.get_ext_state (), sid))
-			{
-			  /* (currently only state maps can keep things
-			     alive).  */
-			  if (logger)
-			    logger->log ("not purging RID: %i for %qE"
-					 " (used by state map)",
-					 rid.as_int (), var);
-			  continue;
-			}
-
-		      /* Don't purge regions containing svalues that
-			 have a change of sm-state, to make it easier to
-			 generate state_change_event messages.  */
-		      if (change)
-			if (change->affects_p (sid))
-			  {
-			    if (logger)
-			      logger->log ("not purging RID: %i for %qE"
-					   " (affected by change)",
-					   rid.as_int (), var);
-			    continue;
-			  }
-		    }
-		  purgeable_ssa_regions.add_region (rid);
-		  ssa_names_to_purge.safe_push (var);
-		  if (logger)
-		    logger->log ("purging RID: %i for %qE", rid.as_int (), var);
-		  /* We also need to remove the region from the map.
-		     We're in mid-traversal, so the removal is done in
-		     unbind below.  */
-		}
-	    }
-	}
 
-      /* Unbind the regions from the frame's map of vars-to-regions.  */
-      unsigned i;
-      tree var;
-      FOR_EACH_VEC_ELT (ssa_names_to_purge, i, var)
-	frame->unbind (var);
-
-      /* Purge the regions.  Nothing should point to them, and they
-	 should have no children, as they are for SSA names.  */
-      new_state.m_region_model->purge_regions (purgeable_ssa_regions,
-					       &stats,
-					       eg.get_logger ());
-#endif
       /* FIXME.  Do this here rather than at add_edge, to cover the
 	 fine-grained cases.  */
       if (num_ssas_purged > 0)
@@ -1876,7 +1119,6 @@ program_state::prune_for_point2 (exploded_graph &eg,
 	  impl_region_model2_context ctxt (eg, enode_for_diag,
 					   this,
 					   &new_state,
-					   change,
 					   point.get_stmt ());
 	  detect_leaks2 (*this, new_state, NULL, eg.get_ext_state (), &ctxt);
 	}
@@ -1910,29 +1152,6 @@ program_state::prune_for_point2 (exploded_graph &eg,
   return new_state;
 }
 
-/* Remap all svalue_ids in this state's m_checker_states according to MAP.
-   The svalues_ids in the region_model are assumed to already have been
-   remapped.  */
-
-void
-program_state::remap_svalue_ids (const svalue_id_map &map)
-{
-  int i;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (m_checker_states, i, smap)
-    smap->remap_svalue_ids (map);
-}
-
-/* Attempt to return a tree that represents SID, or return NULL_TREE.
-   Find the first region that stores the value (e.g. a local) and
-   generate a representative tree for it.  */
-
-tree
-program_state::get_representative_tree (svalue_id sid) const
-{
-  return m_region_model->get_representative_tree (sid);
-}
-
 /* FIXME.  */
 
 tree
